=== po/CMakeLists.txt ===
# CMakeLists for po/

# Find subdirs
SUBDIRS(core defscript modules)
