=== po/core/CMakeLists.txt ===
# CMakeLists for po/core/

# sed will cut paths at this directory
SET(TRANSLATION_BASEDIR "src")

# Find subdirs
SUBDIRS(
	kvirc
	kvs
)
