=== debian/changelog ===
kvirc (4:4.0.2-1) unstable; urgency=low

  The "Leyline of the Void" release

  * New upstream release. (Closes: #590932)
    - Upstream skipped 4.0.1 as an official release.
    - debian/patches/00_upstream_patches_for_4.0.patch: Deleted.
  * debian/source/options: Added to ensure BZip2 compression.
  * debian/watch: Use "latest" directory on FTP server.
  * debian/kvirc.lintian-overrides: Updated.
  * Enable Python scripting support:
    - debian/patches/20_rm_python_stub.patch: Deleted.
    - debian/rules: Removed WITHOUT_PYTHON flag.
    - debian/control: Added python-dev to Build-Depends.

 -- Kai Wasserbäch <debian@carbon-project.org>  Mon, 02 Aug 2010 16:22:44 +0200
