=== debian/watch ===
version=3

# our URL
opts=pasv ftp://ftp.kvirc.de/pub/kvirc/latest/source/kvirc-([\d\.]+)\.tar\.bz2
